## nsis 2.46

=== debian/changelog ===
nsis (2.46-7) unstable; urgency=low

  * Make plugins not depend on libgcc_s_sjlj-1.dll nor libdtdc++-6.dll
    by forcing static compilation of both libgcc and libstdc++. (Closes:
    #654380)

 -- Didier Raboud <odyx@debian.org>  Thu, 05 Jan 2012 19:06:42 +0100

nsis (2.46-6) unstable; urgency=low

  * Corrected command line options passed to scons for build/NEWS target.
  * Use zmemcpy function of the same calling convention. 

 -- Thomas Gaugler <thomas@dadie.net>  Fri, 07 Oct 2011 10:28:21 +0200

nsis (2.46-5) unstable; urgency=low

  * Add Replaces/Breaks against nsis to the new packages (Closes: #630620)

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 18 Jun 2011 16:41:54 +0000

nsis (2.46-4) unstable; urgency=low

  [ Thomas Gaugler ]
  * Run architecture independent build process only when demanded.
  * Split NSIS package into four packages:
    - compiler and utilities (architecture dependent)
    - plugins, stubs and resource files (win32)
    - header and library files for developing NSIS plugins (win32)
    - examples and HTML documentation (architecture independent)
  * Updated to Standards-Version 3.9.2
  * Support building with mingw-w64 (Closes: #620099)
  * Support parallel build 

  [ Didier Raboud ]
  * Don't hide output from scons in clean.
  * Move packaging from Subversion to Git, update Vcs-* fields.
  * Add explicit libstdc++6-4.6-dev Build-Depend.

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 11 Jun 2011 15:24:40 +0000

nsis (2.46-3) experimental; urgency=low

  * Fixed warnings of missing elements occuring in man page generation
  * Use variant_dir instead of build_dir keyword in SConstruct file
  * Run complete set of tests independent of architecture
  * Removed the option to build with the orphaned gcc-mingw32
  * Removed architecture restrictions
  * Updated to Standards-Version 3.9.1

 -- Thomas Gaugler <thomas@dadie.net>  Sun, 07 Nov 2010 17:30:30 +0000

nsis (2.46-2) unstable; urgency=low

  * Updated zlib patch with changes from upstream subversion repository
  * Made embedded inflate function compatible with zlib (Closes: #579407)
  * Exclude unneeded win32-only utilities from building
  * Build makensis and portable utilities natively for amd64

 -- Thomas Gaugler <thomas@dadie.net>  Wed, 05 May 2010 20:39:58 +0000

nsis (2.46-1) unstable; urgency=low

  [ Thomas Gaugler ]
  * New upstream release
  * Switch to 3.0 (quilt) source format
  * Use the system provided compression library of zlib
  * Switch to debhelper 7's minimal rules file mode

  [ Paul Wise ]
  * Link against the 32-bit zlib on amd64 to prevent FTBFS

 -- Thomas Gaugler <thomas@dadie.net>  Tue, 22 Dec 2009 18:53:50 +0000

nsis (2.45-1) unstable; urgency=low

  * New upstream release
  * Adopted package from Paul Wise with his permission
  * Allow building with either gcc-mingw32 (>= 4.4.0-3) or mingw32
  * Fixed occurring access violation in Math plugin once the 
    installer window is closed.

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 17 Aug 2009 19:04:01 +0000

nsis (2.44-4) unstable; urgency=low

  * Brown paper bag upload
  * Actually give the option to dh_strip (closes: #519703)

 -- Paul Wise <pabs@debian.org>  Fri, 20 Mar 2009 12:07:00 +0900

nsis (2.44-3) unstable; urgency=low

  * Don't let dh_strip work on (and break) the libpluginapi.a file
    (Closes: #519703).
  * Support new nocheck option in DEB_BUILD_OPTIONS
  * Bump Standards-Version, nsis now complies

 -- Paul Wise <pabs@debian.org>  Mon, 16 Mar 2009 01:26:29 +0900

nsis (2.44-2) unstable; urgency=low

  * Woops, actually upload to unstable
  * Use dh_lintian instead of manually installing overrides
  * Switch to debhelper compat level 7
  * Switch from dh_clean -k to dh_prep

 -- Paul Wise <pabs@debian.org>  Wed, 25 Feb 2009 01:03:19 +0900

nsis (2.44-1) experimental; urgency=low

  * New upstream bugfix release
    - drop merged fix-Library.nsi-test.patch
  * Move to unstable now that lenny is released
  * Add missing System Call.S copyright info

 -- Paul Wise <pabs@debian.org>  Tue, 24 Feb 2009 17:51:13 +0900

nsis (2.43-1) experimental; urgency=low

  * New upstream release (w00t)
    - Finally makes the System plugin fully functional. Thanks a lot to
      Thomas Gaugler for implementing this (Closes: #319999, LP: #157356)
    - Compiles Resource.dll from an icon and a short .rc (Closes: #442192)
    - Building nsis plugins changes with this release, add details to
      README.Debian and a notification in NEWS.Debian.
  * Add some more items to the TODO file.
  * Apply upstream patch to fix the Library.nsi test
  * Refer to the correct GPL version in the copyright file

 -- Paul Wise <pabs@debian.org>  Thu, 05 Feb 2009 17:52:53 +0900

nsis (2.39-1) experimental; urgency=low

  * New upstream release

 -- Paul Wise <pabs@debian.org>  Wed, 27 Aug 2008 13:09:09 +0800

nsis (2.38-1) experimental; urgency=low

  * New upstream release
    - all patches included
  * Put in experimental because it breaks win32-loader

 -- Paul Wise <pabs@debian.org>  Wed, 16 Jul 2008 16:16:58 +0800

nsis (2.37-2) unstable; urgency=medium

  * Ensure the package will FTBFS when makensis is not built
  * The rebuild should create makensis on amd64 (Closes: #484938)
  * Don't run the patch, build and test process twice
  * Run the tests as well as the test scripts on i386 only
  * Fix FTBFS when converted to dpkg source format 3.0 (Closes: #485350)
  * Bump Standards-Version (no changes needed)

 -- Paul Wise <pabs@debian.org>  Mon, 09 Jun 2008 15:42:38 +0800

nsis (2.37-1) unstable; urgency=low

  * New upstream release
    - all patches included
  * Apply upstream patch to fix the HeaderBitmap test failure

 -- Paul Wise <pabs@debian.org>  Sun, 18 May 2008 18:32:18 +0800

nsis (2.36-1) unstable; urgency=low

  * New upstream release
    - all patches included

 -- Paul Wise <pabs@debian.org>  Mon, 07 Apr 2008 13:35:41 +0800

nsis (2.35-2) unstable; urgency=low

  * Brown paper bag release

