=== debian/watch ===
version=3
http://sf.net/nsis/nsis-([\d.]*)-src.tar.bz2 debian uupdate
