## nsis 2.50

=== debian/changelog ===
nsis (2.50-1) unstable; urgency=medium

  [ Thomas Gaugler ]
  * New upstream release
    - Fixed CreateShortcut failure on Vista caused by security changes
  * Switched to using DocBook 5 and xsltproc for manpage generation
    because the xmlto package has no longer a maintainer.
  * Acknowledge NMU

  [ Didier Raboud ]
  * Refresh all patches for 2.50

 -- Didier Raboud <odyx@debian.org>  Wed, 13 Jan 2016 22:02:48 +0100

nsis (2.48-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use "find -perm /x" instead of "find -perm +x". Closes: #808934

 -- Andreas Metzler <ametzler@debian.org>  Tue, 29 Dec 2015 15:02:57 +0100

nsis (2.48-2) unstable; urgency=medium

  * Build makensis in build-indep to fix indep-only FTBFS

 -- Didier Raboud <odyx@debian.org>  Tue, 15 Dec 2015 15:02:09 +0100

nsis (2.48-1) unstable; urgency=medium

  * New upstream release
    - LoadLibrary security hardening to prevent dll hijacking
      (Bug #1125, Closes: #806036)

  * Updated to Standards-Version 3.9.6
  * Acknowledge NMU

 -- Thomas Gaugler <thomas@dadie.net>  Tue, 15 Dec 2015 10:51:30 +0100

nsis (2.46-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -fgnu89-inline. Closes: #778029.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 13:59:55 +0200

nsis (2.46-10) unstable; urgency=medium

  * Fail the build if libwinpthread is needed at runtime (see #722898)

 -- Didier Raboud <odyx@debian.org>  Mon, 15 Dec 2014 22:58:06 +0100

nsis (2.46-9) unstable; urgency=medium

  [ Didier Raboud ]
  * Update Vcs-* URLs to be canonical.

  [ Thomas Gaugler ]
  * Fix of GCC stdcall attribute warnings occurring for targets other
    than Windows.
  * Overwrite lintian warning about missing Large File Support (LFS). 
  * Replace duplicate image files of Modern UI with symbolic links. 
  * Probe for built makensis instead of using wildcard function.
  * Use correct syntax for invoking shell function from make.
  * Rely on PATH environment for finding mingw-w64 rather than
    explicitly searching for it.
  * Suggest wine package for any architecture it is available.
  * Fix test run on s390x by using stdint.h for portable data type
    definitions. (Closes: #754679)

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 14 Jul 2014 20:25:01 +0200

nsis (2.46-8) unstable; urgency=low

  * Dropped superfluous build dependency of libstdc++6-4.6-dev because
    this build dependency is fulfilled by build-essential. (Closes:
    #747982)
  * Updated to Standards-Version 3.9.5.
  * Use wildcard function of make instead of relying on shell for path
    expansion.
  * Honor hardening flags.
  * Fix of mingw-w64 warnings concerning out of bounds array access.
  * Deploy variables for path names in debian/rules.
  * Upgraded to debhelper version 9.
  * Defined override targets for arch and indep packages.
  * Introduced variables for build directory and type in debian/rules.
  * Retain same flags for build and installation to avoid rebuilding. 

 -- Thomas Gaugler <thomas@dadie.net>  Sun, 25 May 2014 11:35:48 +0200
