=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: optional
 Maintainer: Thomas Gaugler <thomas@dadie.net>
 Uploaders: Didier Raboud <odyx@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), scons (>= 1.2.0), xmlto, html2text, libcppunit-dev, zlib1g-dev, mingw-w64 (>= 1.0), libstdc++6-4.6-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), docbook5-xml, docbook-xsl-ns, html2text, libcppunit-dev, mingw-w64 (>= 1.0), scons (>= 1.2.0), xsltproc, zlib1g-dev
+Standards-Version: 3.9.6
 Homepage: http://nsis.sourceforge.net/
-Vcs-Git: git://git.debian.org/collab-maint/nsis.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/nsis.git
+Vcs-Git: https://alioth.debian.org/anonscm/git/collab-maint/nsis.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nsis.git
 
 Package: nsis
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, nsis-common (>= ${source:Version})
-Suggests: nsis-doc (>= ${source:Version}), nsis-pluginapi (>= ${source:Version}), mingw-w64 (>= 1.0), wine
+Suggests: nsis-doc (>= ${source:Version}), nsis-pluginapi (>= ${source:Version}), mingw-w64 (>= 1.0), wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc]
 Description: Nullsoft Scriptable Install System (modified for Debian)
  NSIS is a tool for creating quick and user friendly installers for
  Microsoft Windows (Win32) operating systems.
